﻿using System;
using System.Threading;

namespace ClockEvent
{
    // inspiration http://www.codeproject.com/Articles/11541/The-Simplest-C-Events-Example-Imaginable
    public class TimeEventArgs : EventArgs
    {
        public TimeEventArgs()
        {
            TimeNow = DateTime.Now;
        }

        public DateTime TimeNow { get; private set; }
    }

    public class Clock
    {
        public event EventHandler<TimeEventArgs> Tick;
        public int SleepTime { get; private set; }

        public Clock(int sleepTime = 1000) { SleepTime = sleepTime; }

        public void Start()
        {
            new Thread(() =>
            {
                while (true)
                {
                    var tick = Tick;
                    tick(this, new TimeEventArgs());
                    Thread.Sleep(SleepTime);
                }
            }).Start();
        }
    }
}
